# -*- coding=utf-8 -*-
# µBackup 5.0 Backup plugin

import os, sys, tarfile, zipfile, locale, gettext, database, sqlite3, ulib, ConfigParser, libftp
from time import strftime, gmtime

# These lines are needed to translate automatically this application
# into supported languages
#app_name = 'ubackup'
#local_path = os.path.realpath(os.path.dirname(sys.argv[0])) + "/i18n"
#langs = []
#lc, encoding = locale.getdefaultlocale()
#if (lc):
#    langs = [lc]
#language = os.environ.get('LANGUAGE', None)
#if (language):
#    langs += language.split(":")
#langs += ["en_US", "it_IT"]
#gettext.bindtextdomain(app_name, local_path)
#gettext.textdomain(app_name)
#lang = gettext.translation(app_name, local_path
#	, languages=langs, fallback = True)
#_ = gettext.gettext

### Credo si tratti solo di una ripetizione di codice inutile. Basta usare questo:
_ = ulib.gettext.gettext
### E dovrebbe funzionare :-)

config = ConfigParser.ConfigParser()
config.read('ubackup.conf')
pattern = config.get('backup', 'pattern')

def robetta(pattern):
	qualcosa = {}
	for robo in pattern.split("-") + pattern.split("."):
		if robo == "%Y":
			qualcosa["year"] = strftime(robo, gmtime())
		elif robo == "%d":
			qualcosa["day"] = strftime(robo, gmtime())
		elif robo == "%m":
			qualcosa["month"] = strftime(robo, gmtime())
		elif robo == "%H":
			qualcosa["hours"] = strftime(robo, gmtime())
		elif robo == "%M":
			qualcosa["minutes"] = strftime(robo, gmtime())
		elif robo == "%S":
			qualcosa["seconds"] = strftime(robo, gmtime())
	
	return qualcosa
	
	
# The function that makes backups in tar.bz2 format
def backup_bz2(directory, ftp):
    print ulib.color(_('<blue>I: Backing-up with tar.bz2 format...</blue>'))
    # This function will give the current date and hour as the name of the backup archive
    dict = robetta(pattern)
	### Il dizionario "dict" contiene tutto quello che ti serve per le informazioni sulla data.
	### Puoi usarlo così:
	### >>> dict["year"]
	### '2010'
	### ecc...
	###
	### Il comando sotto ricrea il pattern per il file tar.bz2, e quindi ci potrà essere un cambio nei
	### secondi o nei minuti. Però a questo ci penseremo più tardi.
	### Forza Inter ;-)				-g7
    name = strftime(pattern, gmtime())
    archive = tarfile.open(name + ".tar.bz2", "w:bz2")
    archive.add("%s" % (directory))
    archive.close()
    archname = name + ".tar.bz2"
    dirs = directory
    print ulib.color(_('<green>I: Done! You can find your backup in the current working dir as</green> <cyan>%s.tar.bz2</cyan><green>!</green>') % (name))
    if ftp == 'y':
        host = config.get('ftp', 'host')
	directory = config.get ('ftp', 'directory')
        destdir = 'ftp://' + host + directory
        database.db.execute('INSERT INTO ftpbackups (year,month,day,hour,mins,secs,archive,dir,destdir) ("%s","%s","%s","%s","%s","%s","%s","%s","%s");' % (year, month, day, hour, mins, secs, archive, dirs, destdir))
        libftp.upload(name + '.tar.bz2')
    else:
        destdir = os.getcwd()
        database.db.execute('INSERT INTO archives (year,month,day,hour,mins,secs,archive,dir,destdir) ("%s","%s","%s","%s","%s","%s","%s","%s","%s");' % (year, month, day, hour, mins, secs, archive, dirs, destdir))
        sys.exit(0)

# The function that makes backups in tar.gz format
def backup_gz(directory, ftp):
    print ulib.color(_('<blue>I: Backing-up with tar.gz format...</blue>'))
    # This function will give the current date and hour as the name of the backup archive
    dict = robetta(pattern)
    name = strftime(pattern, gmtime())
    archive = tarfile.open(name + ".tar.gz", "w:gz")
    archive.add("%s" % (directory))
    archive.close()
    archname = name + ".tar.gz"
    dirs = directory
    print ulib.color(_('<green>I: Done! You can find your backup in the current working dir as</green> <cyan>%s.tar.gz</cyan><green>!</green>') % (name))
    if ftp == 'y':
        host = config.get('ftp', 'host')
	directory = config.get ('ftp', 'directory')
        destdir = 'ftp://' + host + directory
        database.db.execute('INSERT INTO ftpbackups (year,month,day,hour,mins,secs,archive,dir,destdir) ("%s","%s","%s","%s","%s","%s","%s","%s","%s");' % (year, month, day, hour, mins, secs, archive, dirs, destdir))
        libftp.upload(name + '.tar.gz')
    else:
        destdir = os.getcwd()
        database.db.execute('INSERT INTO ftpbackups (year,month,day,hour,mins,secs,archive,dir,destdir) ("%s","%s","%s","%s","%s","%s","%s","%s","%s");' % (year, month, day, hour, mins, secs, archive, dirs, destdir))
        sys.exit(0)

# The function that makes backups in zip format
def backup_zip(directory, ftp):
    print ulib.color(_('<blue>I: Backing-up with zip format...</blue>'))
    # This function will give the current date and hour as the name of the backup archive
    dict = robetta(pattern)
    name = strftime(pattern, gmtime())
    archive = zipfile.ZipFile(name + ".zip", "w")
    archive.write("%s" % (directory))
    archive.close()
    archname = name + ".tzip"
    dirs = directory
    print ulib.color(_('<green>I: Done! You can find your backup in the current working dir as</green> <cyan>%s.zip</cyan><green>!</green>') % (name))
    if ftp == 'y':
        host = config.get('ftp', 'host')
	directory = config.get ('ftp', 'directory')
        destdir = 'ftp://' + host + directory
        database.db.execute('INSERT INTO ftpbackups (year,month,day,hour,mins,secs,archive,dir,destdir) ("%s","%s","%s","%s","%s","%s","%s","%s","%s");' % (year, month, day, hour, mins, secs, archive, dirs, destdir))
        libftp.upload(name + '.zip')
    else:
        destdir = os.getcwd()
        database.db.execute('INSERT INTO ftpbackups (year,month,day,hour,mins,secs,archive,dir,destdir) ("%s","%s","%s","%s","%s","%s","%s","%s","%s");' % (year, month, day, hour, mins, secs, archive, dirs, destdir))
        sys.exit(0)
