# -*- coding=utf-8 -*-
# µBackup 5.0 Library file

# The following lines import necessary modules
import os, sys, locale, gettext, database, sqlite3, compress, ConfigParser, textwrap
from time import strftime, gmtime
#from ftplib import FTP

# These lines are needed to translate automatically this application
# into supported languages
app_name = 'ubackup'
local_path = os.path.realpath(os.path.dirname(sys.argv[0])) + "/i18n"
langs = []
lc, encoding = locale.getdefaultlocale()
if (lc):
    langs = [lc]
language = os.environ.get('LANGUAGE', None)
if (language):
    langs += language.split(":")
langs += ["en_US", "it_IT"]
gettext.bindtextdomain(app_name, local_path)
gettext.textdomain(app_name)
lang = gettext.translation(app_name, local_path
	, languages=langs, fallback = True)
_ = gettext.gettext

# A simple configuration system ;)
config = ConfigParser.ConfigParser()
config.read('ubackup.conf')

# For colored output...
def color(string):
    colors = {"default":0, "black":30, "red":31, "green":32, "yellow":33,
          "blue":34,"magenta":35, "cyan":36, "white":37, "black":38,
          "black":39} #33[%colors%m
    for color in colors:
        color_string = "\033[%dm\033[1m" % colors[color]
        string = string.replace("<%s>" % color, color_string).replace("</%s>" % color, "\033[0m")
    return string

# The following 'def' are the functions that will integrate
# plugins in µBackup

# Backup (base-plugin)
def bk(compression, directory, ftpyn):
    if ftpyn == 'y':
        if compression == 'b':
            compress.backup_bz2(directory, 'y')
        elif compression == 'g':
            compress.backup_gz(directory, 'y')
        elif compression == 'z':
            compress.backup_zip(directory, 'y')
    else:
        if compression == 'b':
            compress.backup_bz2(directory, 'n')
        elif compression == 'g':
            compress.backup_gz(directory, 'n')
        elif compression == 'z':
            compress.backup_zip(directory, 'n')


